/**
 * .file boost/puddle/auxiliary/fwd.hpp
 * .brief Forward declarations
 *
 *  Copyright 2008-2011 Matus Chochlik. Distributed under the Boost
 *  Software License, Version 1.0. (See accompanying file
 *  LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
 */

#ifndef BOOST_PUDDLE_AUXILIARY_FWD_1103151301_HPP
#define BOOST_PUDDLE_AUXILIARY_FWD_1103151301_HPP

#include <boost/puddle/config.hpp>

BOOST_PUDDLE_NAMESPACE_BEGIN
namespace aux {

template <typename IntegralConstant>
struct integer;

template <typename Range>
struct range;

template <typename SpecifierTag>
struct specifier;

template <typename ContainerKindTag>
struct container_kind;

template <typename MetaMetaObject>
struct meta_meta_object;

#define BOOST_PUDDLE_HLPR_FWD_DECL_MO(OBJECT, I, X) \
template <typename MetaObject> \
struct meta_ ## OBJECT;

BOOST_MIRROR_FOR_EACH_META_OBJECT(BOOST_PUDDLE_HLPR_FWD_DECL_MO, 0)

#undef BOOST_PUDDLE_HLPR_FWD_DECL_MO

} // namespace aux
BOOST_PUDDLE_NAMESPACE_END

#endif //include guard

