/**
 * .file boost/puddle/auxiliary/specifier.hpp
 * .brief The specifier wrapper
 *
 *  Copyright 2008-2011 Matus Chochlik. Distributed under the Boost
 *  Software License, Version 1.0. (See accompanying file
 *  LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
 */

#ifndef BOOST_PUDDLE_AUXILIARY_SPECIFIER_1103160725_HPP
#define BOOST_PUDDLE_AUXILIARY_SPECIFIER_1103160725_HPP

#include <boost/puddle/auxiliary/fwd.hpp>
#include <boost/puddle/auxiliary/tag_wrap.hpp>

BOOST_PUDDLE_NAMESPACE_BEGIN
namespace aux {

template <typename Specifier>
struct specifier
 : tag_wrapper<Specifier, boost::mirror::spec__tag>
{
public:
#define BOOST_PUDDLE_HELPER_MAKE_SPECIFIER_IS_X_FUNC(SPEC, KW, GRP, I, X) \
        static bool is_ ## SPEC (void) \
        { \
                return tag_wrapper< \
                        Specifier, \
                        boost::mirror::spec__tag \
                >::is_a(boost::mirror::spec_ ## SPEC ## _tag()); \
        }

BOOST_MIRROR_FOR_EACH_SPECIFIER(BOOST_PUDDLE_HELPER_MAKE_SPECIFIER_IS_X_FUNC, _)

#undef BOOST_PUDDLE_HELPER_MAKE_SPECIFIER_IS_X_FUNC

        static std::string keyword(void)
        {
                return Specifier::keyword();
        }
};

} // namespace aux
BOOST_PUDDLE_NAMESPACE_END

#endif //include guard

